package com.itjob.javanetwork;

import java.nio.ByteBuffer;   
import java.nio.channels.SocketChannel;   
import java.nio.charset.Charset;   
import java.net.InetSocketAddress;   
import java.io.IOException;

/**
 * 第4章 Java的网络编程考题：
 * 使用java.nio及其子包中的类，例如SocketChannel等类，完成如下功能：
 * 读取www.baidu.com等网页的内容，打印到控制台，注意要避免中文乱码问题。
 * @author AmigoXie
 */
public class NioHtmlReader {   
    private Charset charset = Charset.forName("GBK");// 创建GBK字符集   
    private SocketChannel channel;
    
    public void readHTMLContent(String url, int port) {   
        try {   
            InetSocketAddress socketAddress = new InetSocketAddress(url, port);   
            // 1: 打开连接   
            channel = SocketChannel.open(socketAddress);   
            // 2: 发送请求，使用GBK编码   
            channel.write(charset.encode("GET " + "/ HTTP/1.1" + "\r\n\r\n"));   
            // 3: 读取数据，创建1024字节的缓冲
            ByteBuffer buffer = ByteBuffer.allocate(1024);
            while (channel.read(buffer) != -1) {
            	// flip方法在读缓冲区字节操作之前调用
                buffer.flip();
                // 使用Charset.decode方法将字节转换为字符串   
                System.out.println(charset.decode(buffer));
                //  清空缓冲 
                buffer.clear();
            }   
        } catch (IOException e) {   
            System.err.println(e.toString());   
        } finally {   
            if (channel != null) {   
                try {   
                    channel.close();   
                } catch (IOException e) {
                }   
            }   
        }   
    }
    
    public static void main(String[] args) {   
        new NioHtmlReader().readHTMLContent("www.baidu.com", 80);   
    }   
}  
